var frame;
var returnURL = window.location;
var dlgWindow;
var dialog;
var utilityDialog;
var canRefreshCr = false;

//document.domain = "dev.ratlcore.ibm.com";
function showPickerDialog()
{
	var dlg = dijit.byId("oauthFriendsDialog");
	dlg.show();
	resetListBoxes();
	populateFields();
	canRefreshCr = false;
	return;
}

function hidePickerDialog()
{
	var dlg = dijit.byId("oauthFriendsDialog");
	dlg.hide();
	
	if (canRefreshCr)
	{	
		refresh();
	}
	
	return;
}

function populateFields()
{
	OAuthFriendsUtilsAjax.getOAuthFriendsAsJson(token, callbackPopulateFields);
}

function callbackPopulateFields(data)
{
	SelectUtils.clearList("oauth-friends-list");
	
	SelectUtils.addOption("oauth-friends-list", "<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='selectAnOslcFriend' --><!-- PARAM NAME=BUNDLE VALUE='53_patch' --><!-- /WSLET -->", "-1", true);
	
	for (var i = 0; i < data.length; i++)
	{
		SelectUtils.addOption("oauth-friends-list", data[i].displayName, data[i].rootservices, false);
	}
}

function processOnSelect()
{
	displayWaitingSection();
	var friendElem = dojo.byId("oauth-friends-list");
	var index = friendElem.selectedIndex;
	
	var rootServiceUri = friendElem.options[index].value;
	var serviceProviderName = friendElem.options[index].text;
	
	OAuthFriendsUtilsAjax.getServiceCatalogFromAProvider(token, serviceProviderName, rootServiceUri, callbackprocessOnSelect);
}

function callbackprocessOnSelect(data)
{
	var success = false;
	hideWaitingSection();
	
	if (data && data[0] && data[0].needAuthentication)
	{
		postMessageProtocol(data[0].authUrl);
		return;
	}
	
	if (success)
	{
		var friendElem = dojo.byId("oauth-friends-list");
		var index = friendElem.selectedIndex;
		
		var rootServiceUri = friendElem.options[index].value;
		var serviceProviderName = friendElem.options[index].text;
		
		OAuthFriendsUtilsAjax.getServiceCatalogFromAProvider(token, serviceProviderName, rootServiceUri, callbackprocessOnSelect);
	}
	
	SelectUtils.clearList("oauth-friends-services");
	
	for (var i = 0; i < data.length; i++)
	{
		SelectUtils.addOption("oauth-friends-services", data[i].serviceName, data[i].serviceUri, false);
	}
}


function processServiceOnSelect()
{
	displayWaitingSection();
	var serviceElem = dojo.byId("oauth-friends-services");
	var index = serviceElem.selectedIndex;
	
	var mainServiceProvider = dojo.byId("oauth-friends-list");
	
	var rootServicesUri = mainServiceProvider.options[mainServiceProvider.selectedIndex].value;
	
	if (isAValidOption(serviceElem.options[index]))
	{
		var serviceName = serviceElem.options[index].text;
		var serviceUri = serviceElem.options[index].value;
		OAuthFriendsUtilsAjax.getServicesFromAProvider(token, serviceName, serviceUri, rootServicesUri, serviceOnSelectCallback);
	}
}

function serviceOnSelectCallback(data)
{
	hideWaitingSection();
	SelectUtils.clearList("existing-options");
	SelectUtils.clearList("create-options");
	var optionAttr;
	
	for (var i = 0; i < data.length; i++)
	{
		var id = (data[i].dialogForSelection) ? "existing-options" : "create-options";
		
		if (dojo.byId(id).options.length == 0)
		{
			dojo.byId(id).options[0] = addDefaultOption();
		}
		
		optionAttr = SelectUtils.addOption(id, data[i].dialogName, data[i].dialogUri, data[i].dialogDefault);
		optionAttr.setAttribute("frameHeight", data[i].dialogHeight);
		optionAttr.setAttribute("frameWidth", data[i].dialogWidth);
	}
}

function showServiceDialog()
{
	var operationElems = document.getElementsByName("link-operation");
	var operationType = "select";
	
	for (var i = 0; i < operationElems.length; i++)
	{
		if (operationElems[i].checked)
		{
			operationType = operationElems[i].value;
			break;
		}
	}
	
	if (operationType == "select")
	{
		showDialog(dojo.byId("existing-options"));
	}
	else
	{
		showDialog(dojo.byId("create-options"));
	}
}


function showDialog(listElem)
{
	var listOptions = listElem.options;
	
	var index = listOptions.selectedIndex;
	var selectedOption = listOptions[index];
	
	if (!isAValidOption(selectedOption))
	{
		alert("<!-- WSLET CODE=PTString --><!-- PARAM NAME=RESOURCE_STRING VALUE='selectAValidOption' --><!-- PARAM NAME=BUNDLE VALUE='53_patch' --><!-- /WSLET -->");
		return;
	}
	
	var frameHeight = selectedOption.getAttribute("frameHeight");
	var frameWidth = selectedOption.getAttribute("frameWidth");
	
	var dialogUrl = selectedOption.value + "#oslc-postMessage-1.0"
	
	frame = document.createElement('iframe');
	frame.src = dialogUrl;
	frame.width = frameWidth; 
	frame.height = frameHeight;
	frame.scrolling = "yes";
	displayUtilityDialog(frame, selectedOption.text);
}


function displayWindow(frameContent)
{
	if (!dialog) dialog = new dijit.Dialog(); 
	dialog.setContent(frame); 
	dialog.show();
}

function displayUtilityDialog(frameContent, dialogName)
{
	utilityDialog = new dijit.Dialog({title: dialogName});
	utilityDialog.setContent(frameContent); 
	//utilityDialog.startup()
	utilityDialog.show();
}

function closeWindow(frameWindow)
{
	dialog.hide();
}

function postMessageProtocol(dialogURL)
{
	// Step 1
	dialogURL += '#oslc-postMessage-1.0';
   InitEventListener();
   //window.addEventListener('message', listener, false);
   // Step 3
   frame = document.createElement('iframe');
   frame.src = dialogURL;
   frame.width = 450; 
   frame.height = 300;
   displayWindow(frame);
}

function eventListener(e)
{
    var HEADER = "oslc-response:";
    if (e.source == frame.contentWindow && e.data.indexOf(HEADER) == 0)
    {
    	closeUtilityDialog();
       handleMessage(e.data.substr(HEADER.length));
    }
}

function handleMessage(msg)
{
	var data = dojo.fromJson(msg);
	var results = data['oslc_cm:results'];
	var linkUrl;
	var linkLable;
	
	if (results.length == 0)
	{
		return;
	}
	
	for (var i = 0; i < results.length; i++)
	{
		linkUrl = results[i]['rdf:resource'];
		linkLable = results[i]['oslc_cm:label'];
	}
	
	var crId = CtrlUtils.getValue('problem_number');
	OAuthFriendsUtilsAjax.saveLink(token, crId, linkLable, linkUrl, handleMessageCallback);
}

function handleMessageCallback()
{
	canRefreshCr = true;
	closeUtilityDialog();
	return;
}

function closeUtilityDialog()
{
	if (utilityDialog) utilityDialog.hide();
}

function windowNameProtocol(dialogURL) 
{
	/// (5) // Step #1: create iframe with fragment to indicate protocol
	// Step #2: set the iframe's window.name to indicate the Return URL
	var ie = window.navigator.userAgent.indexOf("MSIE"); 
	if (ie > 0) 
	{
		frame = document.createElement('<iframe id="aFrame" name=\'' + returnURL + '\'>');
	}
	else
	{
		frame = document.createElement('iframe'); 
		frame.name = returnURL; 
	}
	
	frame.src = dialogURL + '#oslc-core-windowName-1.0'; 
	frame.width = 450; 
	frame.height = 300; 
	
	displayWindow(frame); 
	
	// Step #3: listen for onload events on the iframe
	if (ie > 0) 
	{ 
		frame.attachEvent("onload", onFrameLoaded); 
	}
	else 
	{ 
		frame.onload = onFrameLoaded; 
	}
}

function InitEventListener()
{
	if (window.addEventListener) {
		window.addEventListener ("message", eventListener, false);
    }
    else {
        if (window.attachEvent) {   // IE before version 9
        	window.attachEvent("onmessage", eventListener);
        }
    }
}

function isAValidOption(option)
{
	return (option.value != "-1" && option.value != "");
}

function addDefaultOption()
{
	var option = new Option();
	option.text = "";
	option.value = "-1";
	
	return option;
}

function displayWaitingSection()
{
	var warningElem = dojo.byId("waiting-section");
	warningElem.style.display = "";
}

function hideWaitingSection()
{
	var warningElem = dojo.byId("waiting-section");
	warningElem.style.display = "none";
}

function resetListBoxes()
{
 var listboxes = ["existing-options", "create-options", "oauth-friends-services"];
 
 for (var i = 0; i < listboxes.length; i++)
 {
	 dojo.byId(listboxes[i]).options.length = 0;
	 dojo.byId(listboxes[i]).options[0] =  addDefaultOption();
 }
}

dojo.addOnLoad(InitEventListener);

